C     *****************
      SUBROUTINE SUREXC(
C     *****************
     >                  NXYZH,NXYTH,NXZTH,NYZTH,
     >                  NXYH,NXZH,NXTH,NYZH,NYTH,NZTH,
     >                  ICC,ILD,TAG,MS,
     >                  LINKS,WK1,NVE,NVH,
     >                  GX,GY,GZ,GT,
     >                  GXY,GXZ,GXT,GYZ,GYT,GZT,
     >                  LX,LY,LZ,LT,
     >                  LXY,LXZ,LXT,LYZ,LYT,LZT,
     >                  NGBX,NGBY,NGBZ,NGBT,
     >                  NGBXY,NGBXZ,NGBXT,NGBYZ,NGBYT,NGBZT)
C
C
C     SUBROUTINE  SUREXC EXCHANGES THE SURFACES OF THE FOUR DIMENSIONAL
C     LATTICE AND PROVIDES PERIODIC BOUNDARY CONDITIONS
C
C
C     LATEST REVISION - NOV. 1989; E.KEHL
C
C
      DOUBLE PRECISION LINKS(NVE,18,4),
     >                 WK1(NVH,18)
C
C
      INTEGER          GX(NYZTH,2,4),GY(NXZTH,2,4),
     >                 GZ(NXYTH,2,4),GT(NXYZH,2,4)
C
      INTEGER          GXY(NZTH,2,4),GXZ(NYTH,2,4),
     >                 GXT(NYZH,2,4),GYZ(NXTH,2,4),
     >                 GYT(NXZH,2,4),GZT(NXYH,2,4)
C
      INTEGER          LX(2,4),LY(2,4),
     >                 LZ(2,4),LT(2,4)
C
      INTEGER          LXY(2,4),LXZ(2,4),
     >                 LXT(2,4),LYZ(2,4),
     >                 LYT(2,4),LZT(2,4)
C
      INTEGER          TAG
C
C
      INTEGER          NGBX(2),NGBY(2),
     >                 NGBZ(2),NGBT(2)
C
      INTEGER          NGBXY(2),NGBXZ(2),
     >                 NGBXT(2),NGBYZ(2),
     >                 NGBYT(2),NGBZT(2)
C
      INTEGER          MS
C
C
C     EXCHANGE OF X-LINKS
C
C
      IF( ILD .EQ. 1 ) THEN
C
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,1,3, LX, NGBX,WK1,ICC,ILD,TAG,MS )
CNOT     CALL SRLKS(
CNOT >        LINKS,NVE, GX,NYZTH,2,4, LX, NGBX,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,1,3, LY, NGBY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,2,4, LY, NGBY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,1,3, LZ, NGBZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,2,4, LZ, NGBZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,1,3, LT, NGBT,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,2,4, LT, NGBT,WK1,ICC,ILD,TAG,MS )
C
         CALL SRLKS(
     >        LINKS,NVE,GXY, NZTH,1,3,LXY,NGBXY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE,GXZ, NYTH,1,3,LXZ,NGBXZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE,GXT, NYZH,1,3,LXT,NGBXT,WK1,ICC,ILD,TAG,MS )
C
      ENDIF
C
C
C     EXCHANGE OF Y-LINKS
C
C
      IF( ILD .EQ. 2 ) THEN
C
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,1,3, LX, NGBX,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,2,4, LX, NGBX,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,1,3, LY, NGBY,WK1,ICC,ILD,TAG,MS )
CNOT     CALL SRLKS(
CNOT >        LINKS,NVE, GY,NXZTH,2,4, LY, NGBY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,1,3, LZ, NGBZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,2,4, LZ, NGBZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,1,3, LT, NGBT,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,2,4, LT, NGBT,WK1,ICC,ILD,TAG,MS )
C
         CALL SRLKS(
     >        LINKS,NVE,GXY, NZTH,2,4,LXY,NGBXY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE,GYZ, NXTH,1,3,LYZ,NGBYZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE,GYT, NXZH,1,3,LYT,NGBYT,WK1,ICC,ILD,TAG,MS )
C
      ENDIF
C
C
C     EXCHANGE OF Z-LINKS
C
C
      IF( ILD .EQ. 3 ) THEN
C
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,1,3, LX, NGBX,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,2,4, LX, NGBX,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,1,3, LY, NGBY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,2,4, LY, NGBY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,1,3, LZ, NGBZ,WK1,ICC,ILD,TAG,MS )
CNOT     CALL SRLKS(
CNOT >        LINKS,NVE, GZ,NXYTH,2,4, LZ, NGBZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,1,3, LT, NGBT,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,2,4, LT, NGBT,WK1,ICC,ILD,TAG,MS )
C
         CALL SRLKS(
     >        LINKS,NVE,GXZ, NYTH,2,4,LXZ,NGBXZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE,GYZ, NXTH,2,4,LYZ,NGBYZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE,GZT, NXYH,1,3,LZT,NGBZT,WK1,ICC,ILD,TAG,MS )
C
      ENDIF
C
C
C     EXCHANGE OF T-LINKS
C
C
      IF( ILD .EQ. 4 ) THEN
C
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,1,3, LX, NGBX,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,2,4, LX, NGBX,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,1,3, LY, NGBY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,2,4, LY, NGBY,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,1,3, LZ, NGBZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,2,4, LZ, NGBZ,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,1,3, LT, NGBT,WK1,ICC,ILD,TAG,MS )
CNOT     CALL SRLKS(
CNOT >        LINKS,NVE, GT,NXYZH,2,4, LT, NGBT,WK1,ICC,ILD,TAG,MS )
C
         CALL SRLKS(
     >        LINKS,NVE,GXT, NYZH,2,4,LXT,NGBXT,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE,GYT, NXZH,2,4,LYT,NGBYT,WK1,ICC,ILD,TAG,MS )
         CALL SRLKS(
     >        LINKS,NVE,GZT, NXYH,2,4,LZT,NGBZT,WK1,ICC,ILD,TAG,MS )
C
      ENDIF
C
C
      RETURN
      END
